#ifndef H_BYTECODE
#define H_BYTECODE

#include <config.h>

typedef int rl_opcode_t;

struct oplist {
	int ops_len;
	rl_opcode_t *ops_list;
};

struct logtab {
	int fd;
	int argv;
	char *path;
};

enum { OP_EXEC=1, OP_FISH, OP_SUID, OP_SGID, OP_NICE,
			 OP_RLIMIT, OP_LOG, OP_CHROOT, OP_ACCEPT, OP_FORK,
			 OP_WRAP, OP_SETCAP, OP_INITGR, OP_BRANCH, OP_CLOSE,
			 OP_BANNER, OP_ZERO, OP_RET, OP_EXIT, OP_ECHO,
			 OP_UP, OP_DOWN, OP_FROG, OP_LSET, OP_LCLR };

#endif /* !H_BYTECODE */
